#ifndef _DWC_IPC_H
#define _DWC_IPC_H

#include <stddef.h>
#include "dwc_type.h"
#include "dwc_timo.h"

#define INVALID_IPC         (NULL)

typedef struct _DWC_ipc*    DWC_ipc_t;

extern DWC_error_code_t     init_ipc_subsystem ( void );
extern DWC_error_code_t     dinit_ipc_subsystem ( void );
extern DWC_string_t         last_ipc_error ( DWC_ipc_t );
extern DWC_error_code_t     create_ipc ( DWC_ipc_type_t, DWC_ipc_t* );
extern DWC_error_code_t     delete_ipc ( DWC_ipc_t* );
extern DWC_error_code_t     addr_ipc_op ( DWC_ipc_t ipc, DWC_cmd_t cmd, DWC_side_t side, DWC_string_t name, DWC_length_t name_len, ... );
extern DWC_error_code_t     bind_ipc ( DWC_ipc_t ipc );
extern DWC_error_code_t     listen_ipc ( DWC_ipc_t ipc, int backlog );
extern DWC_error_code_t     accept_ipc ( DWC_ipc_t, DWC_ipc_t*, DWC_timeout_t );
extern DWC_error_code_t     connect_ipc ( DWC_ipc_t, DWC_timeout_t );
extern DWC_error_code_t     send_ipc ( DWC_ipc_t, DWC_pointer_t, DWC_length_t*, DWC_timeout_t );
extern DWC_error_code_t     recv_ipc ( DWC_ipc_t, DWC_pointer_t, DWC_length_t*, DWC_timeout_t );

#endif /* _DWC_IPC_H */
