#ifndef _DWC_LOG_H
#define _DWC_LOG_H

#if defined(__UNIX_DW)
#include <syslog.h>
#endif /* __UNIX_DW */
#if defined(__WIN32_DW)
#define LOG_DEBUG     0
#define LOG_NOTICE    0
#define LOG_MAIL      0
#endif /* __WIN32_DW */
#include "dwc_lib.h"
#include "dwc_type.h"
#include "dwc_macro.h"

typedef struct {
    int                    code;
    DWC_string_t           name;
} DWC_msg_entry_t;

#define END_OF_TABLE    { -1, NULL }

extern DWC_bool_t   VideoLogEnabled;
extern DWC_bool_t   DebugLogEnabled;
extern DWC_bool_t   LogSyslog;

extern DWC_string_t findWhat( int what, DWC_msg_entry_t Table[] );

extern void         InternalPrint( int facility, const char* fmt, va_list args );
extern void         StartLog( DWC_log_t* log );
extern void         AddLog( DWC_log_t* log, DWC_string_t fmt, ... );
extern void         EndLog( DWC_log_t* log );

#endif /* _DWC_MACRO_H */
