#ifndef _DWC_MACRO_H
#define _DWC_MACRO_H

/*--------------------------------------------------------------------------
 Library for building clients by Dr.Web daemon
                                        ID Antivirus Lab (http://www.drweb.ru)
                                        http://www.drweb.ru/linux-bsd
                                        http://www.drweb.ru/linux-bsd/forum
--------------------------------------------------------------------------*/

#include <stdlib.h>
#include <assert.h>

/*------------------------------------------------------------------------*/
/* defaults values for deamon: */
#define DRWEBD_DEFAULT_IP           "localhost"
#define DRWEBD_DEFAULT_PORT         3000
#define DRWEBD_DEFAULT_SOCKETFILE   "/var/run/drwebd"
#define DRWEBD_DEFAULT_PIDFILE      "/var/run/drwebd.pid"
#define DRWEBD_DEFAULT_TIMEOUT      40000000 /* in microseconds (40 sec) */
#define DRWEBD_DEFAULT_OPTIONS      0x0000
#define MAX_THREADS                 32

/*------------------------------------------------------------------------*/
#define NOP                         do{}while(0)
#define BEGIN_MACRO                 do{
#define END_MACRO                   }while(0)

#define PARAM_ASSERT( expr )        assert( (expr) )

#define NULLCHAR                    '\000'

#define DISABLE                     (0)
#define ENABLE                      (1)

#if defined(__WIN32_DW)
#define PATH_MAX	                _MAX_PATH
#endif

#define DWC_Malloc( type, size )    ((type) malloc( (size) ))
#define DWC_Free( obj )             do{ free( (obj) ); (obj) = NULL; }while(0)

#define DWC_Max( a, b )             ( ((a) > (b)) ? (a) : (b) )
#define DWC_Min( a, b )             ( ((a) > (b)) ? (b) : (a) )

#define DWC_strlen( s )             ( strlen(s) + 1 )

#endif /* _DWC_MACRO_H */
