#ifndef __DRWEBD_SCAN_H
#define __DRWEBD_SCAN_H

/*--------------------------------------------------------------------------
 Dr. Web daemon & client scan commands, options & results codes
                                       ID Antivirus Lab http://www.drweb.ru
                                        http://www.drweb.ru/linux-bsd/forum
                                              http://www.drweb.ru/linux-bsd
--------------------------------------------------------------------------*/

/* -- SCAN_COMMANDS -------------------------------------------------- */
#define DRWEBD_SCAN_CMD             (1)     /* scan file, buffer or diskfile */
#define DRWEBD_VERSION_CMD          (2)     /* get daemon version */
#define DRWEBD_BASEINFO_CMD         (3)     /* get info about viruses bases */
#define DRWEBD_IDSTRING_CMD         (4)     /* get id-string of daemon */
#define DRWEBD_SCANPART_CMD         (5)     /* scan part of diskfile */

/* -- SCAN_OPTIONS ---------------------------------------------------- */
#define DRWEBD_RETURN_VIRUSES       (1<<0)  /* return viruses name */
#define DRWEBD_RETURN_REPORT        (1<<1)  /* return report line */
#define DRWEBD_RETURN_CODES         (1<<2)  /* return codes */
#define DRWEBD_HEURISTIC_ON         (1<<3)  /* enables heuristic */
#define DRWEBD_CURE_FILES           (1<<4)  /* disabled now */

/* -- SCAN_RESALT ----------------------------------------------------- */
#define DERR_MASK                   (0x0000FFFF)
#define DERR_VIRUS_MASK             (0x000000E0)
#define DERR_NOERROR                (0)     /* 0x0000 */
#define DERR_READ_ERR               (1<<0)  /* 0x0001 */
#define DERR_WRITE_ERR              (1<<1)  /* 0x0002 */               
#define DERR_NOMEMORY               (1<<2)  /* 0x0004 */            
#define DERR_CRC_ERROR              (1<<3)  /* 0x0008 */            
#define DERR_READSOCKET             (1<<4)  /* 0x0010 */             
#define DERR_KNOWN_VIRUS            (1<<5)  /* 0x0020 */            
#define DERR_UNKNOWN_VIRUS          (1<<6)  /* 0x0040 */               
#define DERR_VIRUS_MODIFICATION     (1<<7)  /* 0x0080 */             
#define DERR_FILE_IS_CURED          (1<<8)  /* 0x0100 */             
#define DERR_TIMEOUT                (1<<9)  /* 0x0200 */              
#define DERR_SYMLINK                (1<<10) /* 0x0400 */            
#define DERR_NO_REGFILE             (1<<11) /* 0x0800 */             
#define DERR_SKIPPED                (1<<12) /* 0x1000 */           
#define DERR_TOO_BIG                (1<<13) /* 0x2000 */            
#define DERR_TOO_COMPRESSED         (1<<14) /* 0x4000 */           
#define DERR_BAD_CALL               (1<<15) /* 0x8000 */            

#endif /* __DRWEBD_SCAN_H */
