#ifndef __DWC_UNIX_H
#define __DWC_UNIX_H

#if defined(__UNIX_DW) 

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>

#include "dwc_timo.h"
#include "dwc_type.h"

#define INVALID_UNIX_SOCKET    (-1)

typedef int                  DWC_unix_socket_t;
typedef struct sockaddr_un   DWC_unix_socket_addr_t;

extern DWC_error_code_t init_unix_sockets ( void );
extern DWC_error_code_t dinit_unix_sockets ( void );
extern DWC_string_t     last_unix_error ( void );
extern DWC_error_code_t create_unix_socket( DWC_unix_socket_t *sock, DWC_bool_t nonblocking );
extern DWC_error_code_t addr_unix_op ( DWC_cmd_t cmd, DWC_unix_socket_addr_t* addr, DWC_string_t name );
extern DWC_error_code_t bind_unix_socket ( DWC_unix_socket_t sock, DWC_unix_socket_addr_t* addr );
extern DWC_error_code_t listen_unix_socket ( DWC_unix_socket_t sock, int backlog );
extern DWC_error_code_t accept_unix_socket ( DWC_unix_socket_t sock, DWC_unix_socket_addr_t *addr, DWC_unix_socket_t *newsock );
extern DWC_error_code_t connect_unix_socket ( DWC_unix_socket_t sock, DWC_unix_socket_addr_t *addr, DWC_timeout_t timeout );
extern DWC_error_code_t send_unix_socket ( DWC_unix_socket_t sock, DWC_pointer_t buf, DWC_length_t* len_ptr, int options );
extern DWC_error_code_t recv_unix_socket ( DWC_unix_socket_t sock, DWC_pointer_t buf, DWC_length_t* len_ptr, int options );
extern DWC_error_code_t wait_unix_socket( DWC_unix_socket_t sock, int *how, DWC_timeout_t timeout );
extern DWC_error_code_t shutdown_unix_socket ( DWC_unix_socket_t *sock, DWC_unix_socket_addr_t addr, DWC_bool_t linked );
extern DWC_error_code_t close_unix_socket ( DWC_unix_socket_t *sock, DWC_unix_socket_addr_t addr, DWC_bool_t linked );
extern void             cancel_unix_call( DWC_pointer_t sock );

#endif /* __UNIX_DW */

#endif /* __DWC_UNIX_H */
